package de.itstall;

import org.yaml.snakeyaml.Yaml;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

/**
 * Parses an ansible yml config file
 */
public class YamlConfig {
    private String fileLocation;

    /**
     * Gets the FileLocation
     * @return fileLocation : String
     */
    public String getFileLocation() {
        return this.fileLocation;
    }

    /**
     * Sets the FileLocation
     * @param fileLocation : String
     */
    public void setFileLocation(String fileLocation) {
        this.fileLocation = fileLocation;
    }

    /**
     * Read the file from this.fileLocation
     *
     * @return
     */
    public String readFile() {

        Yaml yaml = new Yaml();
        YamlGatewayConfig yamlGatewayConfig = new YamlGatewayConfig();

        try {
            System.out.printf("-- loading from %s --\n", this.getFileLocation());
            Iterable<Object> itr = yaml.loadAll(new String(Files.readAllBytes(Paths.get(getFileLocation()))));

            System.out.println("Loaded object (itr) type:" + itr.getClass());

            List<Object> list = getListFromIterable(itr);

            list.forEach(name -> System.out.printf("Name: " + name.toString()));

            String temp = list.toString();
            System.out.println(temp);

            System.out.println("Loaded object (o) type:" + list.getClass());


        } catch (IOException e) {
            e.printStackTrace();
        }

        return "";
    }

    /**
     * Function to get a List from Iterable
     * @return list : List
     */
    public static <T> List<T> getListFromIterable(Iterable<T> iterable) {

        /** Create a List from the Iterable */
        List<T> list = StreamSupport
                .stream(iterable.spliterator(), true)
                .collect(Collectors.toList());

        return list;
    }

}
